
Redmine - Defect #33576

Done ratio of a parent issue may be shown as 99% even though all subtasks are completed

2020-06-10 08:58 - Go MAEDA

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Issues Estimated time: 0.00 hour

Target version: 4.0.8   

Resolution: Fixed Affected version: 4.0.0

Description

Due to a rounding error at source:tags/4.1.1/app/models/issue.rb#L1717, a parent task may show 99% done even when all subtasks

are 100% done.
irb(main):001:0> 1610 / 16.1

=> 99.99999999999999

 Steps to reproduce:

1. Set "% Done" setting (Administration > Settings > Issue tracking) to "Calculated from subtasks"

2. Create a parent task.

3. Create a subtask 1 with 10.0 estimated hours and 100% done ratio

4. Create a subtask 2 with 6.1 estimated hours and 100% done ratio

5. Now the done ratio of the parent task shows 99% instead of 100%

Related issues:

Related to Redmine - Defect #27848: The progress exceeding 99.5% is displayed... Closed

Related to Redmine - Defect #37151: The done ratio of a parent issue may not ... Closed

Associated revisions

Revision 19818 - 2020-06-14 08:56 - Go MAEDA

Done ratio of a parent issue may be shown as 99% even though all subtasks are completed (#33576).

Patch by Go MAEDA.

Revision 19819 - 2020-06-14 08:58 - Go MAEDA

Merged r19818 from trunk to 4.1-stable (#33576).

Revision 19820 - 2020-06-14 09:00 - Go MAEDA

Merged r19818 from trunk to 4.0-stable (#33576).

History

#1 - 2020-06-10 08:58 - Go MAEDA

- Related to Defect #27848: The progress exceeding 99.5% is displayed as 100% added

#2 - 2020-06-10 10:20 - Go MAEDA

- File fix-33576.patch added

- Target version set to Candidate for next minor release

Attaching a patch that fixes the issue.

#3 - 2020-06-10 11:34 - Go MAEDA

- File fix-33576-v2.patch added

Updated the patch not to use Float in the calculation process of a derived done ratio.
#4 - 2020-06-10 13:04 - Anonymous

- File 4.jpg added

#5 - 2020-06-10 17:06 - Go MAEDA

- File deleted (4.jpg)

#6 - 2020-06-11 15:50 - Go MAEDA

- Target version changed from Candidate for next minor release to 4.0.8

Setting the target version to 4.0.8.

#7 - 2020-06-14 09:01 - Go MAEDA

- Subject changed from Parent task may show 99% done even when all subtasks are 100% done to Done ratio of a parent issue may be shown as

99% even though all subtasks are completed

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch.

#8 - 2020-06-15 20:26 - Sebastian Paluch

There are also other issues in Done ration calculation #21449

#9 - 2022-05-24 04:21 - Go MAEDA

- Related to Defect #37151: The done ratio of a parent issue may not be 100% even if all subtasks have a done ratio of 100% added

Files
